#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <dos.h>   	/* function time */
#include <string.h>

#include "allegro.h"

#define PanelWidth 20
#define PanelHeight 23
#define FichaWidth 4
#define FichaHeight 4
#define MargenIzda 10
#define MargenSup 10

#define BLACK 0
#define WHITE 63
#define GRAY 32
#define RED 64
#define GREEN 65
#define BLUE 66
#define YELLOW 67
#define CYAN 68
#define MAGENTA 69
#define PINK 70
#define ORANGE 71
#define VIOLET 72

#define COPYRIGHT "(C) Juan I. Prez Sacristn"

#define DELETE 8
#define ESC 27
#define ENTER 13

/*********************
* Variables globales *
*********************/
FILE *d;

PALLETE pal;
struct s_record {
	int puntos;
	char nombre[100];
} record[10];
int i, j, k;
int color[8]={BLACK, RED, CYAN, BLUE, YELLOW, ORANGE, MAGENTA, PINK};
int temporizador;
int flagtimer;
int puntos, vidas;
int fin_partida, fin;
int panel[PanelWidth][PanelHeight];
int ficha[28][FichaWidth][FichaHeight] = {
	/* triangulo */
	{
		{0,0,0,0},
		{0,0,1,0},
		{0,1,1,1},
		{0,0,0,0}
	},
	{
		{0,0,0,0},
		{0,0,1,0},
		{0,0,1,1},
		{0,0,1,0}
	},
	{
		{0,0,0,0},
		{0,0,0,0},
		{0,1,1,1},
		{0,0,1,0}
	},
	{
		{0,0,0,0},
		{0,0,1,0},
		{0,1,1,0},
		{0,0,1,0}
	},
	/* 4 horizontal*/
	{
		{0,0,0,0},
		{0,0,0,0},
		{2,2,2,2},
		{0,0,0,0}
	},
	{
		{0,0,2,0},
		{0,0,2,0},
		{0,0,2,0},
		{0,0,2,0}
	},
	{
		{0,0,0,0},
		{0,0,0,0},
		{2,2,2,2},
		{0,0,0,0}
	},
	{
		{0,0,2,0},
		{0,0,2,0},
		{0,0,2,0},
		{0,0,2,0}
	},
	/* escalon 1 */
	{
		{0,0,0,0},
		{0,0,3,3},
		{0,3,3,0},
		{0,0,0,0}
	},
	{
		{0,0,0,0},
		{0,3,0,0},
		{0,3,3,0},
		{0,0,3,0}
	},
	{
		{0,0,0,0},
		{0,0,3,3},
		{0,3,3,0},
		{0,0,0,0}
	},
	{
		{0,0,0,0},
		{0,3,0,0},
		{0,3,3,0},
		{0,0,3,0}
	},
	/* escalon 2 */
	{
		{0,0,0,0},
		{0,4,4,0},
		{0,0,4,4},
		{0,0,0,0}
	},
	{
		{0,0,0,0},
		{0,0,4,0},
		{0,4,4,0},
		{0,4,0,0}
	},
	{
		{0,0,0,0},
		{0,4,4,0},
		{0,0,4,4},
		{0,0,0,0}
	},
	{
		{0,0,0,0},
		{0,0,4,0},
		{0,4,4,0},
		{0,4,0,0}
	},
	/* ele 1 */
	{
		{0,0,0,0},
		{0,5,0,0},
		{0,5,5,5},
		{0,0,0,0}
	},
	{
		{0,0,0,0},
		{0,5,5,0},
		{0,5,0,0},
		{0,5,0,0}
	},
	{
		{0,0,0,0},
		{5,5,5,0},
		{0,0,5,0},
		{0,0,0,0}
	},
	{
		{0,0,5,0},
		{0,0,5,0},
		{0,5,5,0},
		{0,0,0,0}
	},
	/* ele 2 */
	{
		{0,0,0,0},
		{0,6,6,6},
		{0,6,0,0},
		{0,0,0,0}
	},
	{
		{0,0,0,0},
		{0,6,6,0},
		{0,0,6,0},
		{0,0,6,0}
	},
	{
		{0,0,0,0},
		{0,0,6,0},
		{6,6,6,0},
		{0,0,0,0}
	},
	{
		{0,6,0,0},
		{0,6,0,0},
		{0,6,6,0},
		{0,0,0,0}
	},
	/* cuadro */
	{
		{0,0,0,0},
		{0,7,7,0},
		{0,7,7,0},
		{0,0,0,0}
	},
	{
		{0,0,0,0},
		{0,7,7,0},
		{0,7,7,0},
		{0,0,0,0}
	},
	{
		{0,0,0,0},
		{0,7,7,0},
		{0,7,7,0},
		{0,0,0,0}
	},
	{
		{0,0,0,0},
		{0,7,7,0},
		{0,7,7,0},
		{0,0,0,0}
	}
};
int fichax, fichay, fichaxold=-10, fichayold, orientacion, orientacionold;
int fichaactual, fichapost, orienpost;
char c;
int sonido = 0;


void timer_juego(void);


void rectangulo(int i, int j, int col)
{
	int c;

	if ((col>=8)||(col<0)) {allegro_exit();printf("Error: col = %d\n", col);exit(-1);}
	c = color[col];
	i=i*8 + MargenIzda;
	j=j*8 + MargenSup;

	hline(screen, i, j, i+7, c);
	vline(screen, i, j, j+7, c);
	vline(screen, i+7, j, j+7, c);
	hline(screen, i, j+7, i+7, c);
	line(screen, i, j, i+7, j+7, c);
	line(screen, i+7, j, i, j+7, c);
}

void borra_ficha(void)
{
	if (fichaxold==-10) return;
	for(i=0;i<FichaWidth;i++)
	{
		for(j=0;j<FichaHeight;j++)
		{
			if (ficha[fichaactual*4 + orientacionold][i][j]!=0) rectangulo(i + fichaxold - 1, j + fichayold, 0);
		}
	}
}

void dibuja_ficha(void)
{
	fichaxold=fichax;
	fichayold=fichay;
	orientacionold=orientacion;
	for(i=0;i<FichaWidth;i++)
	{
		for(j=0;j<FichaHeight;j++)
		{
			if (ficha[fichaactual*4 + orientacion][i][j]!=0) rectangulo(i + fichax - 1, j + fichay, ficha[fichaactual*4 + orientacion][i][j]);
		}
	}
}

void dibuja_vidas(void)
{
	static char texto[100] = " ";

	textout(screen, font, texto, 200, 60, BLACK);
	sprintf(texto, "EXTRA = %d", vidas);
	textout(screen, font, texto, 200, 60, WHITE);
}

void dibuja_velocidad(void)
{
	static char texto[100] = " ";

	textout(screen, font, texto, 200, 100, BLACK);
	sprintf(texto, "SPEED = %d ms", temporizador);
	textout(screen, font, texto, 200, 100, WHITE);
}

void dibuja_puntos(void)
{
	static char texto[100] = " ";

	textout(screen, font, texto, 200, 20, BLACK);
	sprintf(texto, "SCORE = %d", puntos);
	if (sonido)
	{
		sound(100);
		delay(10);
		sound(200);
		delay(10);
		sound(300);
		delay(10);
		nosound();
	}
	textout(screen, font, texto, 200, 20, WHITE);
}

void dibuja_panel(void)
{
	int i, j;
	static int x1, y1, x2, y2 = -1;

	if (y2 == -1)
	{
		x1 = MargenIzda;
		y1 = MargenSup;
		x2 = MargenIzda + 8*(PanelWidth-2) - 1;
		y2 = MargenSup + 8*(PanelHeight-1) - 1;
	}
	rectfill(screen, x1, y1, x2, y2, BLACK);
	for(i=1;i<PanelWidth - 1;i++)
	{
		for(j=0;j<PanelHeight - 1;j++)
		{
			if (panel[i][j]!=0) rectangulo(i - 1, j, panel[i][j]);
		}
	}
}

#define XPOST 20
#define YPOST 5

void dibuja_fichapost(void)
{
	for(i=0;i<FichaWidth;i++)
	{
		for(j=0;j<FichaHeight;j++)
		{
			if (ficha[fichapost*4 + orienpost][i][j]!=0) rectangulo(i + XPOST - 1, j + YPOST, ficha[fichapost*4 + orienpost][i][j]);
		}
	}
}

void borra_fichapost(void)
{
	for(i=0;i<FichaWidth;i++)
	{
		for(j=0;j<FichaHeight;j++)
		{
			if (ficha[fichapost*4 + orienpost][i][j]!=0) rectangulo(i + XPOST - 1, j + YPOST, BLACK);
		}
	}
}

int ficha_abajo(void)
{
	for(i=0;i<FichaWidth;i++)
	{
		for(j=0;j<FichaHeight;j++)
		{
			if (ficha[fichaactual*4 + orientacion][i][j]!=0)
			{
				if ((i + fichax >= 0) && (i + fichax < PanelWidth) && (j + 1 + fichay >= 0) && (j + 1 + fichay < PanelHeight))
				{
					if (panel[i + fichax][j + 1 + fichay]!=0) return(1);
				}
			}
		}
	}
	return(0);
}

int ficha_izda(void)
{
	for(i=0;i<FichaWidth;i++)
	{
		for(j=0;j<FichaHeight;j++)
		{
			if (ficha[fichaactual*4 + orientacion][i][j]!=0)
			{
				if ((i + fichax - 1 >= 0) && (i + fichax - 1 < PanelWidth) && (j + fichay >= 0) && (j + fichay < PanelHeight))
				{
					if (panel[i + fichax - 1][j + fichay]!=0) return(1);
				}
			}
		}
	}
	return(0);
}

int ficha_dcha(void)
{
	for(i=0;i<FichaWidth;i++)
	{
		for(j=0;j<FichaHeight;j++)
		{
			if (ficha[fichaactual*4 + orientacion][i][j]!=0)
			{
				if ((i + fichax + 1 >= 0) && (i + fichax + 1 < PanelWidth) && (j + fichay >= 0) && (j + fichay < PanelHeight))
				{
					if (panel[i + fichax + 1][j + fichay]!=0) return(1);
				}
			}
		}
	}
	return(0);
}

int ficha_reloj(void)
{
	int ori;

	ori=orientacion;
	if (ori==3) ori=0; else ori++;
	for(i=0;i<FichaWidth;i++)
	{
		for(j=0;j<FichaHeight;j++)
		{
			if (ficha[fichaactual*4 + ori][i][j]!=0)
			{
				if ((i + fichax >= 0) && (i + fichax < PanelWidth) && (j + fichay >= 0) && (j + fichay < PanelHeight))
				{
					if (panel[i + fichax][j + fichay]!=0) return(1);
				}
			}
		}
	}
	return(0);
}

int ficha_antireloj(void)
{
	int ori;

	ori=orientacion;
	if (ori==0) ori=3; else ori--;
	for(i=0;i<FichaWidth;i++)
	{
		for(j=0;j<FichaHeight;j++)
		{
			if (ficha[fichaactual*4 + ori][i][j]!=0)
			{
				if ((i + fichax >= 0) && (i + fichax < PanelWidth) && (j + fichay >= 0) && (j + fichay < PanelHeight))
				{
					if (panel[i + fichax][j + fichay]!=0) return(1);
				}
			}
		}
	}
	return(0);
}

int ficha_posible(void)
{
	for(i=0;i<FichaWidth;i++)
	{
		for(j=0;j<FichaHeight;j++)
		{
			if (ficha[fichaactual*4 + orientacion][i][j]!=0)
			{
				if ((i + fichax >= 0) && (i + fichax < PanelWidth) && (j + fichay >= 0) && (j + fichay < PanelHeight))
				{
					if (panel[i + fichax][j + fichay]!=0) return(1);
				}
			}
		}
	}
	return(0);
}

void ficha_colocada(void)
{
	int completa;
	int filas_completas;

	for(i=0;i<FichaWidth;i++)
	{
		for(j=0;j<FichaHeight;j++)
		{
			if (ficha[fichaactual*4 + orientacion][i][j]!=0)
			{
				panel[i + fichax][j + fichay]=ficha[fichaactual*4 + orientacion][i][j];
			}
		}
	}
	puntos++;
	filas_completas=0;
	for(j=0;j<PanelHeight-1;j++)
	{
		completa=1;
		for(i=1;i<PanelWidth-1;i++)
		{
			if (panel[i][j]==0) completa = 0;
		}
		if (completa)
		{
			for(i=1;i<PanelWidth-1;i++)
			{
				for(k=j;k>0;k--)
				{
					panel[i][k]=panel[i][k-1];
				}
				panel[i][0]=0;
			}
			dibuja_panel();
			puntos+=20;
			filas_completas++;
			j=0;
			if (sonido)
			{
				for (k=100;k<1000;k+=20) {sound(k);delay(5);}
				nosound();
			}
		}
	}
	if (filas_completas==2)
	{
		temporizador = (temporizador*110)/100;
		if (temporizador>500) temporizador=500;
		install_int(timer_juego, temporizador);
		dibuja_velocidad();
		if (sonido)
		{
			for (k=100;k<1000;k+=5) {sound(k);delay(5);}
			nosound();
		}
		puntos+=40;
	}
	else if (filas_completas==3)
	{
		temporizador = (temporizador*125)/100;
		if (temporizador>500) temporizador=500;
		install_int(timer_juego, temporizador);
		dibuja_velocidad();
		if (sonido)
		{
			for (k=100;k<1000;k+=4) {sound(k);delay(5);}
			nosound();
		}
		puntos+=60;
	}
	else if (filas_completas==4)
	{
		vidas++;
		dibuja_vidas();
		if (sonido)
		{
			for (k=2000;k<4000;k+=3) {sound(k);delay(1);}
			nosound();
		}
		puntos+=100;
	}
	dibuja_puntos();
	fichaxold=-10;
	fichax = 1 + random()%(PanelWidth - 5);
	fichay = 0;
	fichaactual = fichapost;
	orientacion = orienpost;
	borra_fichapost();
	fichapost = random()%7;
	orienpost = random()%4;
	dibuja_fichapost();
	if (ficha_posible())
	{
		vidas--;
		if (vidas<0)
		{
			fin_partida=1;
			return;
		}
		dibuja_vidas();
		if (sonido)
		{
			for (k=1000;k<2000;k+=10) {sound(k);delay(5);}
			for (k=1000;k<2000;k+=10) {sound(k);delay(5);}
			nosound();
		}
		temporizador=500;
		install_int(timer_juego, temporizador);
		dibuja_velocidad();
		for(i=1;i<PanelWidth-1;i++)
		{
			for(k=(PanelHeight - 2);k>7;k--)
			{
				panel[i][k]=panel[i][k-8];
			}
			for(k=0;k<8;k++)
			{
				panel[i][k]=0;
			}
		}
		dibuja_panel();
	}
	temporizador = temporizador*99/100;
	install_int(timer_juego, temporizador);
	dibuja_velocidad();
	dibuja_puntos();
}

void gameover(void)
{
	clear_keybuf();
	textout_centre(screen, font, "G A M E   O V E R", 1 + SCREEN_W/2, 1 + SCREEN_H/2, GRAY);
	textout_centre(screen, font, "G A M E   O V E R", SCREEN_W/2, SCREEN_H/2, WHITE);
	readkey();
}

void edit_text(int x, int y, int num, char *text, int bg, int fg)
{
	char c;
	int l, w, h, x1, y1, x2, y2;
	char copia[1024];

	text[0] = '\0';
	l = 0;
	h = text_height(font);
	w = num * text_length(font, "W");
	x1 = x - w/2;
	x2 = x + w/2;
	y1 = y - h/2;
	y2 = y + h/2;

	rectfill(screen, x1, y1, x2, y2, bg);
	textout(screen, font, text, x1, y1, fg);
	clear_keybuf();
	while ((c = (readkey() & 0xff))!=ENTER)
	{
		if (c == DELETE)
		{
			if (l>0)
			{
				strcpy(copia, text);
				text[l-1] = '\0';
				textout(screen, font, copia, x1, y1, bg);
				textout(screen, font, text, x1, y1, fg);
				l--;
			}
		}
		else if (c == ESC)
		{
			fade_out(5);
			allegro_exit();
			exit(0);
		}
		else
		{
			if (l < num-1)
			{
				text[l] = c;
				text[l+1] = '\0';
				textout(screen, font, text, x1, y1, fg);
				l++;
			}
		}
	}
}

void load_records(void)
{
	FILE *fr;
	int i;

	fr = fopen("records.tet", "rt");
	if (fr == NULL) {allegro_exit();printf("Error: Unable to open records.tet\n");exit(-1);}
	for(i=0;i<10;i++)
	{
		fscanf(fr, "%d\t%s\n", &record[i].puntos, record[i].nombre);
	}
	fclose(fr);
}

void save_records(void)
{
	FILE *fr;

	fr = fopen("records.tet", "wt");
	if (fr == NULL) {allegro_exit();printf("Error: Unable to open records.tet\n");exit(-1);}
	for(i=0;i<10;i++)
	{
		fprintf(fr, "%d\t%s\n", record[i].puntos, record[i].nombre);
	}
	fclose(fr);
}

int sort_function(const void *a, const void *b)
{
	int x, y;

	x = ((struct s_record *)a)->puntos;
	y = ((struct s_record *)b)->puntos;
	if (x < y) return +1;
	else if (x == y) return 0;
	else return -1;
}

void ordena_records(void)
{
	qsort((void *)record, 10, sizeof(record[0]), sort_function);
}

void muestrarecords(void)
{
	char texto[100];

	load_records();
	ordena_records();
	clear(screen);
	for(i=0;i<10;i++)
	{
		sprintf(texto, "%d", record[i].puntos);
		textout(screen, font, texto, 10, 10 +15*i, WHITE);
		sprintf(texto, "%s", record[i].nombre);
		textout(screen, font, texto, 140, 10 +15*i, WHITE);
	}
	readkey();
}

void nuevo_record(void)
{
	char texto[100];
	int posicion = 0;
	int i;

	load_records();
	ordena_records();
	if (puntos < record[9].puntos) return;

	record[9].puntos = puntos;
	strcpy(record[9].nombre, COPYRIGHT);
	ordena_records();

	clear(screen);
	strcpy(texto, "*** N E W   R E C O R D ***");
	textout_centre(screen, font, texto, SCREEN_W/2, 30, WHITE);
	sprintf(texto, "SCORE = %d", puntos);
	textout_centre(screen, font, texto, SCREEN_W/2, 50, WHITE);
	while (strcmp(record[posicion].nombre, COPYRIGHT) != 0) posicion++;
	sprintf(texto, "POSITION = %d", posicion + 1);
	textout_centre(screen, font, texto, SCREEN_W/2, 70, WHITE);
	sprintf(texto, "Write down your name:");
	textout_centre(screen, font, texto, SCREEN_W/2, 120, WHITE);
	edit_text(SCREEN_W/2, 150, 10, record[posicion].nombre, GRAY, WHITE);
	save_records();
	delay(100);
}

void presentacion(void)
{
	int tmp, i;
	PALLETE pal;
	BITMAP *fondo;

	tmp = set_gfx_mode(GFX_MODEX, 320, 240, 0, 0);
		if (tmp != 0) {printf("allegro_error = %s\n", allegro_error); exit(-1);}
	fondo = load_pcx("titulo.pcx", pal);
	set_pallete(pal);
	blit(fondo, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	delay(100);
	if (sonido)
	{
		for (j=0;j<2000;j+=50)
		{
			sound(j);
			delay(2);
		}
		for (j=0;j<2000;j+=50)
		{
			sound(j);
			delay(2);
		}
		nosound();
	}
	clear_keybuf();
	for (i=0;i<50;i++)
	{
		if (keypressed()) {c = (readkey() & 0xff); break;}
		delay(100);
	}
	if (c == 27) fin = 1;

	free(fondo);
}

void timer_juego(void)
{
	flagtimer = TRUE;
}
END_OF_FUNCTION(timer_juego);

void haz_mientras(void)
{
	if (!flagtimer) return;
	flagtimer = FALSE;

	if (ficha_abajo()) ficha_colocada();
	else
	{
		fichay++;
		borra_ficha();
		dibuja_ficha();
	}
}

void partida(void)
{
	unsigned long count=0;
	int press = 0;

	fin_partida=0;
	clear(screen);
	for(i=1;i<PanelWidth - 1;i++)
	{
		for(j=0;j<PanelHeight - 1;j++)
		{
			panel[i][j]=0;
		}
	}
	for(i=0;i<PanelWidth;i++) panel[i][PanelHeight - 1] = 1;
	for(j=0;j<PanelHeight - 1;j++) panel[0][j] = panel[PanelWidth - 1][j] = 1;
	puntos = 0;
	vidas = 0;
	temporizador = 500;
	dibuja_panel();
	dibuja_puntos();
	dibuja_vidas();
	dibuja_velocidad();
	fichax = 1 + random()%(PanelWidth - 5);
	fichay = 0;
	fichaactual = random()%7;
	orientacion = random()%4;
	borra_fichapost();
	fichapost = random()%7;
	orienpost = random()%4;
	dibuja_fichapost();
	hline(screen, MargenIzda-1, MargenSup-1, 8*(PanelWidth-2) + MargenIzda, WHITE);
	vline(screen, MargenIzda-1, MargenSup-1, 8*(PanelHeight-1) + MargenSup, WHITE);
	vline(screen, 8*(PanelWidth-2) + MargenIzda, MargenSup-1, 8*(PanelHeight-1) + MargenSup, WHITE);
	hline(screen, MargenIzda-1, 8*(PanelHeight-1) + MargenSup, 8*(PanelWidth-2) + MargenIzda, WHITE);

	dibuja_panel();
	install_int(timer_juego, temporizador);
	while (!fin_partida)
	{
		while ((key[KEY_LEFT]) && (!ficha_izda()))
		{
			haz_mientras();
			fichax--;
			borra_ficha();
			dibuja_ficha();
			if (press) delay(50); else {delay(150); press = 1;}
		}
		press = 0;
		while ((key[KEY_RIGHT]) && (!ficha_dcha()))
		{
			haz_mientras();
			fichax++;
			borra_ficha();
			dibuja_ficha();
			if (press) delay(50); else {delay(150); press = 1;}
		}
		press = 0;
		if ((key[KEY_UP]) && (!ficha_reloj()))
		{
			if (orientacion==3) orientacion=0; else orientacion++;
			borra_ficha();
			dibuja_ficha();
			delay(180);
		}
		if ((key[KEY_DOWN]) && (!ficha_antireloj()))
		{
			if (orientacion==0) orientacion=3; else orientacion--;
			borra_ficha();
			dibuja_ficha();
			delay(180);
		}
		if (key[KEY_SPACE])
		{
			int altura;

			delay(150);
			altura = 0;
			while (!ficha_abajo())
			{
				altura++;
				fichay++;
				borra_ficha();
				dibuja_ficha();
			}
			puntos+=altura/4;
		}
		if (key[KEY_ESC]) fin_partida = 1;

		haz_mientras();

/*		delay(temporizador/10000);
		if (++count%20==0)
		{
			if (ficha_abajo()) ficha_colocada();
			else
			{
				fichay++;
				borra_ficha();
				dibuja_ficha();
			}
		}*/
	}
	remove_int(timer_juego);
}

void dibuja_menu(int opcion)
{
	char texto[100];
	int color[4] = {GRAY, GRAY, GRAY, GRAY};
	BITMAP *offscreen;

	offscreen = create_bitmap(SCREEN_W, SCREEN_H);
	clear(offscreen);
	color[opcion] = WHITE;
	strcpy(texto, "P L A Y   T E T R I S");
	textout_centre(offscreen, font, texto, SCREEN_W/2, 40, color[0]);
	strcpy(texto, "O P T I O N S");
	textout_centre(offscreen, font, texto, SCREEN_W/2, 90, color[1]);
	strcpy(texto, "R E C O R D S");
	textout_centre(offscreen, font, texto, SCREEN_W/2, 140, color[2]);
	strcpy(texto, "E X I T");
	textout_centre(offscreen, font, texto, SCREEN_W/2, 190, color[3]);
	blit(offscreen, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	free(offscreen);
}

void opciones(void)
{
	if (sonido) sonido = 0;
	else sonido = 1;
}

void menu(void)
{
	int opcion = 0;

	clear_keybuf();
	do {
		dibuja_menu(opcion);

		c = (readkey() >> 8);
		if (c == KEY_ESC) {fin = 1; return;}
		else if (c == KEY_UP)
		{
			if (opcion > 0) opcion--;
			else opcion = 3;
			if (sonido) {sound(1);delay(1);nosound();}
		}
		else if (c == KEY_DOWN)
		{
			if (opcion < 3) opcion++;
			else opcion = 0;
			if (sonido) {sound(1);delay(1);nosound();}
		}
	}  while (c != KEY_ENTER);

	if (sonido) {sound(100);delay(1);nosound();}
	if (opcion == 0)
	{
		partida();
		gameover();
		nuevo_record();
		muestrarecords();
	}
	else if (opcion == 1)
	{
		opciones();
	}
	else if (opcion == 2)
	{
		muestrarecords();
	}
	else if (opcion == 3)
	{
		fin = 1;
	}
}

/*
void prueba_pal(void)
{
	char texto[100];
	int h;

	h = text_height(font) + 2;
	sprintf(texto, "Red");
	textout_centre(screen, font, texto, SCREEN_W/2, 0, RED);
	sprintf(texto, "Green");
	textout_centre(screen, font, texto, SCREEN_W/2, h, GREEN);
	sprintf(texto, "Blue");
	textout_centre(screen, font, texto, SCREEN_W/2, 2*h, BLUE);
	sprintf(texto, "Yellow");
	textout_centre(screen, font, texto, SCREEN_W/2, 3*h, YELLOW);
	sprintf(texto, "Orange");
	textout_centre(screen, font, texto, SCREEN_W/2, 4*h, ORANGE);
	sprintf(texto, "Magenta");
	textout_centre(screen, font, texto, SCREEN_W/2, 5*h, MAGENTA);
	sprintf(texto, "Pink");
	textout_centre(screen, font, texto, SCREEN_W/2, 6*h, PINK);
	sprintf(texto, "Violeta");
	textout_centre(screen, font, texto, SCREEN_W/2, 7*h, VIOLET);
	sprintf(texto, "Cyan");
	textout_centre(screen, font, texto, SCREEN_W/2, 8*h, CYAN);
	while (!kbhit());
	while (kbhit()!=0) getch();
}
*/

void init_pal(void)
{
	int tmp;

	for (tmp=0;tmp<64;tmp++)
	{
		pal[tmp].r = pal[tmp].g = pal[tmp].b = tmp;
	}
	pal[RED].r = 63; pal[RED].g = 0; pal[RED].b = 0;
	pal[GREEN].r = 0; pal[GREEN].g = 63; pal[GREEN].b = 0;
	pal[BLUE].r = 0; pal[BLUE].g = 0; pal[BLUE].b = 63;
	pal[YELLOW].r = 63; pal[YELLOW].g = 63; pal[YELLOW].b = 0;
	pal[CYAN].r = 0; pal[CYAN].g = 63; pal[CYAN].b = 63;
	pal[ORANGE].r = 63; pal[ORANGE].g = 32; pal[ORANGE].b = 0;
	pal[MAGENTA].r = 63; pal[MAGENTA].g = 0; pal[MAGENTA].b = 63;
	pal[PINK].r = 63; pal[PINK].g = 32; pal[PINK].b = 32;
	pal[VIOLET].r = 32; pal[VIOLET].g = 0; pal[VIOLET].b = 63;
	set_pallete(pal);
}


void main(int argc, char *argv[])
{
	struct time hora;
	int tmp, i;

	d = fopen("t.log", "wt");
	allegro_init();
	install_timer();
	LOCK_VARIABLE(flagtimer);
/*	LOCK_VARIABLE(flag_ficha_colocada);
	LOCK_VARIABLE(flag_ficha_abajo);*/
	LOCK_FUNCTION(timer_juego);
	install_keyboard();
	presentacion();

	fin = 0;
	gettime(&hora);
	srandom(hora.ti_sec);

	text_mode(-1);
	solid_mode();

	init_pal();
	while (!fin) menu();
	fade_out(5);
	allegro_exit();
	fclose(d);
}